<?php
use Ims\Shophelper\Classes\Dhlauthc\DHLAuth as DHL;
use Lovata\Shopaholic\Models\Offer;
use Lovata\Shopaholic\Models\Product;
use Lovata\Shopaholic\Models\Currency;
const URL_SITE = 'https://marianorubinacci.com';
const DHL_BASE_URL = 'https://express.api.dhl.com/mydhlapi';
//const URL_SITE = 'https://dev.marianorubinacci.com';
//const DHL_BASE_URL = 'https://express.api.dhl.com/mydhlapi/test';
const DHL_USER = 'apR4oV4aX6mO5h';
const DHL_PASS = 'Z^4lX$7dP$1r';
$obOrder = $formModel;
date_default_timezone_set('Europe/Rome');
function buildHtmlList($array)
{
    $out = '';
    if(is_array($array)){
        $out = '<ul>';
        foreach($array as $key => $v) {
            if( is_array($v) ) {
                $out .= '<li>';
                $out  .= buildHtmlList($v);
                $out .= '</li>';
                continue;
            } else {
                $out .= '<li>' . $array[$key] . '</li>';
            }
        }
        $out .= '</ul>';
    }else{
        $out .= '<span>'.$array.'</span>';
    }
    return $out;
}

function walk($array)
{    
    //convert object to key-value array
    if(isset($array)){
        if (is_object($array)) {
            $array = (array)$array;
        }
        echo "<ul>";
        foreach ($array as $key => $value) {
            echo "<li>";
            echo $key;
            if (is_int($value) || is_string($value)) {
                echo ":" . $value;
            } elseif (is_array($value) || is_object($value)) {
                walk($value);
            }
            echo "</li>";
        }
        echo "</ul>";
    }
}
function walkItems($array)
{    
    //convert object to key-value array
    if(isset($array)){
        if (is_object($array)) {
            $array = (array)$array;
        }
        foreach ($array as $key => $value) {
            if($key == 'description' || $key == 'price' || $key == 'quantity' || $key == 'value'){
                echo "<li>";
                if(!is_numeric($key))
                    echo $key;
                if (is_int($value) || is_string($value) || is_float($value)) {
                    if(is_float($value)){
                        echo " : " . $value . " &euro;";
                    }else{
                        echo " : " . $value;
                    }
                }
                echo "</li>";
            }
            if (is_array($value) || is_object($value)) {
                echo "<ul>";
                walkItems($value);
                echo "</ul>";
            }
        }
    }
}

function isEU($countrycode) {
    $eu_countrycodes = array(
        'AT', 'BE', 'BG', 'CY', 'CZ', 'DE', 'DK', 'EE', 'EL',
        'ES', 'FI', 'FR', 'GR', 'HR', 'HU', 'IE', 'IT', 'LT', 'LU', 'LV',
        'MC', 'MT', 'NL', 'PL', 'PT', 'RO', 'SE', 'SI', 'SK'
    );
    return (in_array($countrycode, $eu_countrycodes));
}

$country_state = empty($obOrder->property['shipping_state']) ? $obOrder->property['billing_state'] : $obOrder->property['shipping_state'];

?>
<style>
    .checkbox-menu li label {
        display: block;
        padding: 3px 10px;
        clear: both;
        font-weight: normal;
        line-height: 1.42857143;
        color: #333;
        white-space: nowrap;
        margin:0;
        transition: background-color .4s ease;
    }
    .checkbox-menu li input {
        margin: 0px 5px;
        top: 2px;
        position: relative;
    }
    
    .checkbox-menu li.active label {
        background-color: #cbcbff;
        font-weight:bold;
    }
    
    .checkbox-menu li label:hover,
    .checkbox-menu li label:focus {
        background-color: #f5f5f5;
    }
    
    .checkbox-menu li.active label:hover,
    .checkbox-menu li.active label:focus {
        background-color: #b8b8ff;
    }
</style>
<div class="modal fade rounded" id="exampleModal" tabindex="1" role="dialog" aria-labelledby="exampleModalLabel" aria-hidden="true">
    <div class="modal-dialog" role="document">
        <div class="modal-content">
            <div class="modal-header">
                <h3 class="modal-title" id="exampleModalLabel">Gestione pacco</h3>
                <button type="button" class="close" data-dismiss="modal" aria-label="Close">
                    <span aria-hidden="true">&times;</span>
                </button>
            </div>
            <div class="modal-body">
                <div class="layout-row">
                    <div id="Form-primaryTabs" class="control-tabs primary-tabs layout has-tabs" data-control="tab">
                        <div class="layout-row min-size">
                            <ul id="appendTab" class="nav nav-tabs" data-linkable="" data-disposable="">
                                <li style="cursor: pointer;" id="addPackButton">
                                    <a onclick="addPack()" title="Aggiungi Pacco">
                                        <span class="title">
                                            <span class="text-info">+</span>
                                        </span>
                                    </a>
                                </li>
                            </ul>
                        </div>
                        <div class="tab-content layout-row active" id="appendContentTab">
                                
                        </div>
                    </div>
                </div>
            </div>
            <div class="modal-footer">
                <button type="button" class="btn btn-secondary" data-dismiss="modal">Close</button>
                <button type="button" class="btn btn-primary" onclick="savePackages()">Save changes</button>
            </div>
        </div>
    </div>
</div>

<div class="form-group span-left" style="padding: 15px !important;" id="colonnaDhlSx">
    <div class="row">
        <div class="col-3">
            <label for="OrderHelper[shipping_date_requested]">Data di Spedizione*</label>
            <input min="<?= date('d/m/Y H:m') ?>" type="datetime-local" id="shipping_date_requested" name="OrderHelper[shipping_date_requested]" class="form-control">
        </div>
        <div class="col-3">
            <label for="OrderHelper[shipping_duty_payment_type]">Pagamento dazi doganali</label>
            <input type="text" id="shipping_duty_payment_type" name="OrderHelper[shipping_duty_payment_type]" class="form-control" value="<?= ($obOrder->dazi_value != 0) ? 'Si' : 'No' ?>" readonly>
        </div>
        <div class="col-1">
            <label for="OrderHelper[shipping_reference]">Numero fattura*</label>
            <input type="text" id="shipping_reference" name="OrderHelper[shipping_reference]" class="form-control">
        </div>
        <div class="col-2">
            <label for="OrderHelper[shipping_date_billing]">Data Fattura*</label>
            <input type="date" id="shipping_date_billing" name="OrderHelper[shipping_date_billing]" class="form-control">
        </div>
        <div class="col-2" style="margin-top: 10px !important;">
            <label for="Fattura">Fattura di Pagamento</label>
            <input type="file" id="document_invoice" name="document_invoice" class="form-control" accept=".pdf">
        </div>
        <div class="col-2" style="margin-top: 10px !important;">
            <label for="Fattura">Fattura Doganale</label>
            <input type="file" id="document_cin" name="document_cin" class="form-control" accept=".pdf">
        </div>
    </div>
</div>
<div class="form-group span-right" style="padding: 15px !important;" id="colonnaDhlDx">
    <div class="row">
        <?php if((!isEU($country_state)) && (is_file(storage_path('app/media/shipmentsLabel/'.$obOrder->id.'/etichetta_partenza_'.$obOrder->id.'.pdf')))){ ?>
            <div class="col-12">
                <label for="multi-select">Articoli da Rendere</label>
                <div id="select-wrapper-429322" class="select-wrapper">
                    <div class="dropdown">
                        <button class="btn btn-primary dropdown-toggle" type="button" id="dropdownMenu1" data-toggle="dropdown" aria-haspopup="true" aria-expanded="true">
                            <span class="fw-bold" style="font-size: 15px;">Seleziona</span>
                            <span class="caret"></span>
                        </button>
                        <ul style="width: 100%;" class="dropdown-menu checkbox-menu allow-focus" aria-labelledby="dropdownMenu1" id="selected_prodotti">
                            <?php foreach($obOrder->order_position as $positions){ 
                                $offer = Offer::where('id',$positions->item_id)->first();
                                $product = Product::where('id',$offer->product_id)->first();
                                $curr_rate = floatval(Currency::where('id',$obOrder->currency_id)->first()->rate);
                                $couponDiscount = count($obOrder->order_promo_mechanism) > 0 ? $obOrder->order_promo_mechanism->first()->discount_value : 0;
                                if($couponDiscount > 0){
                                    $couponPrice = round($positions->price_value * ((100-$couponDiscount)/100),0);
                                    $newprice = round(round(((($couponPrice)*$positions->quantity)/1.22),0)/$curr_rate,0);
                                }else{
                                    $newprice = round(round((($positions->price_value*$positions->quantity)/1.22),2)/$curr_rate,2);
                                }
                            ?>
                                <li>
                                    <label style="font-size: 17px;"><input type="checkbox" name="position_<?=$positions->id?>"><?php echo $product->name . " - " . $offer->name . " - " . $newprice . "&euro;" ?></label>
                                </li>
                            <?php } ?>
                        </ul>
                    </div>
                </div>
            </div>
        <?php } ?>
        <div class="col-3">
            <label for="OrderHelper[shipping_account]">Account</label>
            <select id="shipping_account" name="OrderHelper[shipping_account]" class="form-control">
                <?php if(!empty($obOrder->shipping_account)){ 
                    if($obOrder->shipping_account === '105257899'){
                ?>
                        <option value="105257899" selected>105257899</option>
                        <option value="106173837">106173837</option>
                    <?php }else{ ?>
                        <option value="105257899">105257899</option>
                        <option value="106173837" selected>106173837</option>
                    <?php } ?>
                <?php }else{ ?>
                <option value="105257899">105257899</option>
                <option value="106173837">106173837</option>
                <?php } ?>
            </select>
        </div>
        <div class="col-3">
            <label for="OrderHelper[shipping_number_reference]">Numero REF</label>
            <input type="text" id="shipping_number_reference" name="OrderHelper[shipping_number_reference]" class="form-control">
        </div>
        <div class="col-3">
            <label id="labelmodalpack" for="modale">Aggiungi pacchi</label><br>
            <button style="font-size: 16px; font-family: Arial, Helvetica, sans-serif !important;" id="pluspack" type="button" class="btn btn-primary" data-toggle="modal" data-target="#exampleModal"> +</button>
        </div>
        <div class="col-3" style="margin-top: 10px !important;">
            <label for="quotazione">Tipo di Spedizione</label>
            <select id="quotazione" name="packagesQuoatation" class="form-control"></select>
        </div>
        <div class="col-2" style="margin-top: 10px !important;">
            <label for="Fattura">Altri Allegati (1)</label>
            <input type="file" id="document_others_1" name="document_others_1" class="form-control" accept=".pdf">
        </div>
        <div class="col-2" style="margin-top: 10px !important;">
            <label for="Fattura">Altri Allegati (2)</label>
            <input type="file" id="document_others_2" name="document_others_2" class="form-control" accept=".pdf">
        </div>
        <div class="col-2" style="margin-top: 10px !important;">
            <label for="Fattura">Altri Allegati (3)</label>
            <input type="file" id="document_others_3" name="document_others_3" class="form-control" accept=".pdf">
        </div>
    </div>
</div>
<div class="form-group span-left" style="padding: 15px !important; border-top: 2px solid rgba(114, 114, 114, 0.712) !important;" id="labelButtonGroup">
    <div class="row">
        <p style="font-size:18px; padding-bottom: 5px !important;">Azioni</p>
        <div class="col-3" id="appendLabel">
            <button id="quoteDHL" type="button" class="btn btn-primary mx-2" onclick="calculate_quotation()">Quotazione</button>
            <?php if(!isEU($country_state)){ ?>
                <button id="sendShippingEmailSend" type="button" class="btn btn-primary" onclick="create_shipment_dhl_send()">Crea etichetta di Partenza</button>
                <?php if(is_file(storage_path('app/media/shipmentsLabel/'.$obOrder->id.'/etichetta_partenza_'.$obOrder->id.'.pdf'))){ ?>
                    <button id="sendShippingEmailReso" type="button" class="btn btn-primary" onclick="create_shipment_dhl_return()">Crea etichetta di Reso</button>
                <?php }else{ ?>
                    <button id="sendShippingEmailReso" type="button" class="btn btn-primary" onclick="create_shipment_dhl_return()" disabled="true">Crea etichetta di Reso</button>
                <?php } ?>
            <?php } else{ ?>
                <button id="sendShippingEmail" type="button" class="btn btn-primary" onclick="create_shipment_dhl()">Crea etichetta</button>
            <?php } ?>
            <?php if(!empty($obOrder->tracking_url_dhl)): ?>
                <button id="riepilogoButton" style="font-size: 14px;" type="button" class="btn btn-primary" data-toggle="modal" data-target="#exampleModal2">Riepilogo Spedizione</button>
            <?php endif; ?>
            <?php if(is_file(storage_path('app/media/shipmentsLabel/'.$obOrder->id.'/etichetta_partenza_'.$obOrder->id.'.pdf'))) { ?>
                <a id='partenzaLabel' class='btn btn-success text-white' onclick="downloadLabel('partenza,<?= $obOrder->id ?>')">
                    Etichetta
                    <i style="font-size: 22px;" class="icon-file-pdf-o">&nbsp;<i style="font-size: 22px;" class="icon-arrow-up"></i></i>
                </a>
            <?php } ?>
            <?php if(is_file(storage_path('app/media/shipmentsLabel/'.$obOrder->id.'/etichetta_reso_'.$obOrder->id.'.pdf'))) { ?>
                <a id='ritornoLabel' class='btn btn-danger text-white' onclick="downloadLabel('reso,<?= $obOrder->id ?>')">
                    Etichetta Reso
                    <i style="font-size: 22px;" class="icon-file-pdf-o">&nbsp;<i style="font-size: 22px;" class="icon-arrow-down"></i></i>
                </a>
                <?php if(is_file(storage_path("app/media/log_send_reso_dhl_".$obOrder->id.".txt"))){ ?>
                    <button id="riepilogoButtonReso" style="font-size: 14px;" type="button" class="btn btn-primary" data-toggle="modal" data-target="#exampleModal3">Riepilogo Spedizione Reso</button>
                <?php } ?>
            <?php } ?>
        </div>
    </div>
</div>

<!-- RIEPILOGO SPEDIZIONE -->
<div class="modal" id="exampleModal2" tabindex="-1" role="dialog">
    <div class="modal-dialog" role="document">
      <div class="modal-content">
        <div class="modal-header">
            <button type="button" class="close" data-dismiss="modal" aria-label="Close">
                <span aria-hidden="true">&times;</span>
            </button>
            <h4 class="title">Riepilogo Spedizione</h4>
        </div>
        <div class="modal-body row  p-0 m-0">
            <?php 
                if(!empty($obOrder->tracking_url_dhl)){
                    $dhltrack = new DHL(URL_SITE,DHL_BASE_URL,DHL_USER,DHL_PASS);
                    $track = $dhltrack->get_tracking($obOrder->tracking_url_dhl);
            ?>
                <table class="table striped-table table-responsive" style="width: 100%;">
                    <thead>
                        <tr>
                        </tr>
                    </thead>
                    <tbody>
                        <tr id='codice_utente'>
                        </tr>
                        <?php
                            if(isset($track['shipments'])){
                                foreach($track['shipments'][0] as $key => $value) { ?>
                                    <tr>
                                        <th style="border: 1px solid rgb(150, 150, 150);" scope="col"><?= $key ?></th>
                                        <td><?= buildHtmlList($value) ?></td>
                                    </tr>
                        <?php } } ?>
                    </tbody>
                </table>
            <?php } ?>
        </div>
        <div class="modal-footer">
          <button type="button" class="btn btn-secondary" data-dismiss="modal">Chiudi</button>
        </div>
      </div>
    </div>
</div>
<div class="modal" id="exampleModal3" tabindex="-1" role="dialog">
    <div class="modal-dialog" role="document">
      <div class="modal-content">
        <div class="modal-header">
            <button type="button" class="close" data-dismiss="modal" aria-label="Close">
                <span aria-hidden="true">&times;</span>
            </button>
            <h4 class="title">Riepilogo Spedizione Reso</h4>
        </div>
        <?php if(is_file(storage_path("app/media/log_send_reso_dhl_".$obOrder->id.".txt"))){ ?>
            <?php $ogg = json_decode(file_get_contents(storage_path("app/media/log_send_reso_dhl_".$obOrder->id.".txt"))); ?>
            <div class="modal-body row  p-0 m-0">
                <table class="table striped-table table-responsive" style="width: 100%;">
                    <tbody>
                        <tr>
                            <th style="border: 1px solid rgb(150, 150, 150);" scope="col">
                                Data Spedizione Reso
                            </th>
                            <td><?= $ogg->plannedShippingDateAndTime ?></td>
                        </tr>
                        <tr>
                            <th style="border: 1px solid rgb(150, 150, 150);" scope="col">
                                Account Spedizione Reso
                            </th>
                            <td><?= $ogg->accounts[0]->number ?></td>
                        </tr>
                        <tr>
                            <th style="border: 1px solid rgb(150, 150, 150);" scope="col">
                                Totale Reso
                            </th>
                            <td><?= $ogg->content->declaredValue ?> &euro;</td>
                        </tr>
                        <tr>
                            <th style="border: 1px solid rgb(150, 150, 150);" scope="col">Mittente</th>
                            <td><?= walk($ogg->customerDetails->shipperDetails) ?></td>
                        </tr>
                        <tr>
                            <th style="border: 1px solid rgb(150, 150, 150);" scope="col">Destinatario</th>
                            <td><?= walk($ogg->customerDetails->receiverDetails) ?></td>
                        </tr>
                        <tr>
                            <th style="border: 1px solid rgb(150, 150, 150);" scope="col">Prodotti Resi</th>
                            <td><?= walkItems($ogg->content->exportDeclaration->lineItems) ?></td>
                        </tr>
                    </tbody>
                </table>
            </div>
        <?php } ?>
        <div class="modal-footer">
          <button type="button" class="btn btn-secondary" data-dismiss="modal">Chiudi</button>
        </div>
      </div>
    </div>
</div>
<!-- RIEPILOGO SPEDIZIONE -->

<textarea style="display: none;" id="base64"></textarea>
<textarea style="display: none;" id="base64_cin"></textarea>
<textarea style="display: none;" id="base64_others_1"></textarea>
<textarea style="display: none;" id="base64_others_2"></textarea>
<textarea style="display: none;" id="base64_others_3"></textarea>


<div style="display: none;" id="checkdirexist"><?= is_file(storage_path('app/media/shipmentsLabel/'.$obOrder->id.'/etichetta_partenza_'.$obOrder->id.'.pdf')) && is_file(storage_path('app/media/shipmentsLabel/'.$obOrder->id.'/etichetta_partenza_'.$obOrder->id.'.pdf')) ?></div>
<script>
    $(".checkbox-menu").on("change", "input[type='checkbox']", function() {
        $(this).closest("li").toggleClass("active", this.checked);
    });
    
    $(document).on('click', '.allow-focus', function (e) {
        e.stopPropagation();
    });

    function downloadLabel(params) {
        $.request('onDownload', {
           data: {
               'order_id': params,
           },
            flash: 1,
            handleFlashMessage: function(message, type) {
                $.oc.flashMsg({ text: message, class: type })
            },
            success: function(data) { 
                var origin = window.location.origin;
                window.location.href = origin+'/'+data.result;
            }, 
        });
    }
    var packCounter = 1;

    var pkgTotalJSON = [];
    var partenza = 0;
    function savePackages(){
        var packages_json = [];
        var content_json = {};
        $("#appendContentTab").children('div').find('input').each(function(){
            var input_id = $(this).attr('id');
            if(!(input_id.split('-')[0] in content_json)){
                content_json[input_id.split('-')[0]] = {};
            }
            content_json[input_id.split('-')[0]][input_id.split('-')[1]] = $(this).val();
        });
        $("#appendContentTab").children('div').find('select').each(function(){
            var select_id = $(this).attr('id');
            if(!(select_id.split('-')[0] in content_json)){
                content_json[select_id.split('-')[0]] = {};
            }
            content_json[select_id.split('-')[0]][select_id.split('-')[1]] = $(this).val();
        });
        packages_json.push(content_json);
        pkgTotalJSON = packages_json;

        if (packCounter >= 2) {
            var newCounter = packCounter-1;
            $('#pluspack').text(' Gestisci Pacchi ('+newCounter+')');
        } else {
            $('#pluspack').html(' +');
        }
        $('#exampleModal').modal('toggle');
    }

    function addPack() {
        if (packCounter > 7) {
            return false;
        }
        if($("[idremove="+packCounter+"]").length !== 0){
            packCounter++;
            return false;
        }
        $('[name="tabformcontrol"]').each(function() {
            $(this).removeClass('active');
        });
        $('#appendTab').append(`
            <li idremove="`+packCounter+`" name="tabformcontrol" class="active">
                <a href="#`+packCounter+`" data-target="#`+packCounter+`_tab" data-toggle="tab" title="Pacco n° `+packCounter+`">
                    <span style="cursor: pointer;" class="title">
                        <span id="packPack_`+packCounter+`">Pacco `+packCounter+`</span>
                    </span>
                </a>
            </li>
        `);
        $('#appendContentTab').append(`
            <div idremove="`+packCounter+`" name="tabformcontrol" class="tab-pane layout-cell row active" id="`+packCounter+`_tab">
                <div style="cursor: pointer;" class="w-100 text-center">
                    <div class="btn-sm btn-danger" onclick="removePack(`+packCounter+`)">Elimina</div>
                </div>
                <div class="form-group">
                    <label for="OrderHelper[pack_weight_`+packCounter+`]">Peso pacco</label>
                    <input type="text" id="pack_weight-`+packCounter+`" name="OrderHelper[pack_weight_`+packCounter+`]" class="form-control">
                </div>
                <div class="form-group">
                    <label for="OrderHelper[shipping_package_type_`+packCounter+`]">Dimensioni pacco*</label>
                    <select id="shipping_package_type-`+packCounter+`" name="OrderHelper[shipping_package_type_`+packCounter+`]" class="form-control">
                        <option vlun="27" vlar="27" valt="5" value="A">A  =&gt;  [27 x 27 x 5] cm</option>
                        <option vlun="40" vlar="13" valt="6" value="B">B  =&gt;  [40 x 13 x 6] cm</option>
                        <option vlun="34" vlar="20" valt="13" value="C">C  =&gt;  [34 x 20 x 13] cm</option>
                        <option vlun="41" vlar="41" valt="7" value="D">D  =&gt;  [41 x 41 x 7] cm</option>
                        <option vlun="47" vlar="32" valt="5" value="E">E  =&gt;  [47 x 32 x 5] cm</option>
                        <option vlun="45" vlar="35" valt="13" value="F">F  =&gt;  [45 x 35 x 13] cm</option>
                        <option vlun="59" vlar="46" valt="10" value="G">G  =&gt;  [59 x 46 x 10] cm</option>
                        <option vlun="25" vlar="20" valt="3" value="H">H  =&gt;  [25 x 20 x 3] cm</option>
                        <option vlun="24" vlar="35" valt="3" value="I">I  =&gt;  [24 x 35 x 3] cm</option>
                    </select>
                </div>
                <div class="form-group">
                    <label for="OrderHelper[shipping_contents_`+packCounter+`]">Descrizione contenuto*</label>
                    <input type="text" id="shipping_contents-`+packCounter+`" name="OrderHelper[shipping_contents_`+packCounter+`]" class="form-control">
                </div>
            </div> 
        `);
        //element to move
        var $el = $("li[idremove='"+packCounter+"']");

        //move element down one step
        if ($el.not(':last-child'))
            $el.next().after($el);

        //move element up one step
        if ($el.not(':first-child'))
            $el.prev().before($el);

        //move element to top
        $el.parent().prepend($el);

        //move element to end
        $el.parent().append($el);
        packCounter++;
    }

    function removePack(params) {
        if(packCounter>=params){
            packCounter = params;
        }
        $("[idremove="+params+"]").remove();
    }

    // Check for the File API support.
    if (window.File && window.FileReader && window.FileList && window.Blob) {
        document.getElementById('document_invoice').addEventListener('change', handleFileSelect, false);
        document.getElementById('document_invoice').parametro = 'base64';

        document.getElementById('document_cin').addEventListener('change', handleFileSelect, false);
        document.getElementById('document_cin').parametro = 'base64_cin';
        
        document.getElementById('document_others_1').addEventListener('change', handleFileSelect, false);
        document.getElementById('document_others_1').parametro = 'base64_others_1';

        document.getElementById('document_others_2').addEventListener('change', handleFileSelect, false);
        document.getElementById('document_others_2').parametro = 'base64_others_2';

        document.getElementById('document_others_3').addEventListener('change', handleFileSelect, false);
        document.getElementById('document_others_3').parametro = 'base64_others_3';
    }
    
    function handleFileSelect(evt) {
        console.log(evt);
        var f = evt.target.files[0]; // FileList object
        var reader = new FileReader();
        // Closure to capture the file information.
        reader.onload = (function(theFile) {
        return function(e) {
            var binaryData = e.target.result;
            //Converting Binary Data to base 64
            var base64String = window.btoa(binaryData);
            //showing file converted to base64
            document.getElementById(evt.target.parametro).value = '';
            document.getElementById(evt.target.parametro).value = base64String;
        };
        })(f);
        // Read in the image file as a data URL.
        reader.readAsBinaryString(f);
    }

    function create_shipment_dhl_send(){
        var newCreateShipping = 'create_shipping_send';
        var spediz_code = $('#quotazione').find(':selected').val();
        var local_spediz_code = $('#quotazione').find(':selected').attr('localcode');
        var spediz_description = $('#quotazione').find(':selected').text().replace(" €","");
        var data_spediz = $("#shipping_date_requested").val();
        let plannedShippingDate = new Date(data_spediz);
        var shipping_contents = $('#shipping_contents').val();
        var shipping_reference = $('#shipping_reference').val();
        var number_reference = $('#shipping_number_reference').val();
        var shipping_date_billing = $('#shipping_date_billing').val();
        var shipping_duty_payment_type = $('#shipping_duty_payment_type').val();
        var shipping_account = $('#shipping_account').val();
        var document_invoice = $('#base64').val();
        var document_cin = $('#base64_cin').val();
        var document_others_1 = $('#base64_others_1').val();
        var document_others_2 = $('#base64_others_2').val();
        var document_others_3 = $('#base64_others_3').val();
        if(document_others_1 == ''){
            document_others_1 = "nil";
        }
        if(document_others_2 == ''){
            document_others_2 = "nil";
        }
        if(document_others_3 == ''){
            document_others_3 = "nil";
        }
        if(document_cin == ''){
            document_cin = "nil";
        }
        $.request('onInterfaceShipping2', {
            data: {
                'search' : newCreateShipping,
                'order_id': "<?=$obOrder->id?>",
                'params':{
                    'productCode':spediz_code,
                    'localProductCode':local_spediz_code,
                    'spedizDescr':spediz_description,
                    'packages': pkgTotalJSON[0],
                    'document_invoice': document_invoice,
                    'document_cin': document_cin,
                    'document_others_1': document_others_1,
                    'document_others_2': document_others_2,
                    'document_others_3': document_others_3,
                    'data_spediz' : plannedShippingDate.toLocaleDateString("en-CA"),
                    'shipping_contents' : shipping_contents, 
                    'shipping_reference' : shipping_reference, 
                    'shipping_number_reference' : number_reference, 
                    'shipping_date_billing' : shipping_date_billing, 
                    'shipping_duty_payment_type' : shipping_duty_payment_type, 
                    'shipping_account' : shipping_account
                },
            },
            flash: 1,
            handleFlashMessage: function(message, type) {
                $.oc.flashMsg({ text: message, class: type })
            },
            success: function(data) {
                console.log(data);
                if (data.error) {
                    // handle the error
                    throw data.error.msg;
                }
                var json_result = JSON.parse(data.result);
                    if($('#partenzaLabel').length !== 0){
                        $('#partenzaLabel').remove();
                    }
                    $('#appendLabel').append(`
                        <a id='partenzaLabel' class='btn btn-success text-white' download='etichetta_partenza.pdf' href='data:application/octet-stream;base64,`+json_result.documents[0].content+`'>
                            Etichetta
                            <i style="font-size: 22px;" class="icon-file-pdf-o">&nbsp;<i style="font-size: 22px;" class="icon-arrow-up"></i></i>
                        </a>
                    `);
                    window.location.reload();
            }
        });
    }

    function create_shipment_dhl_return(){
        var newCreateShippingReturn = 'create_shipping_return';
        var spediz_code = $('#quotazione').find(':selected').val();
        var local_spediz_code = $('#quotazione').find(':selected').attr('localcode');
        var spediz_description = $('#quotazione').find(':selected').text().replace(" €","");
        var data_spediz = $("#shipping_date_requested").val();
        let plannedShippingDate = new Date(data_spediz);
        var shipping_contents = $('#shipping_contents').val();
        var shipping_reference = $('#shipping_reference').val();
        var number_reference = $('#shipping_number_reference').val();
        var shipping_date_billing = $('#shipping_date_billing').val();
        var shipping_duty_payment_type = $('#shipping_duty_payment_type').val();
        var shipping_account = $('#shipping_account').val();
        var document_invoice = $('#base64').val();
        var document_cin = $('#base64_cin').val();
        var document_others_1 = $('#base64_others_1').val();
        var document_others_2 = $('#base64_others_2').val();
        var document_others_3 = $('#base64_others_3').val();
        var selected_return_products = [];
        $('#selected_prodotti').find('input').each(function(){
            if($(this).is(':checked')){
                selected_return_products.push($(this).attr('name'));   
            }
        });
        if(document_others_1 == ''){
            document_others_1 = "nil";
        }
        if(document_others_2 == ''){
            document_others_2 = "nil";
        }
        if(document_others_3 == ''){
            document_others_3 = "nil";
        }
        if(document_cin == ''){
            document_cin = "nil";
        }
        $.request('onInterfaceShipping2', {
            data: {
                'search' : newCreateShippingReturn,
                'order_id': "<?=$obOrder->id?>",
                'params':{
                    'productCode':spediz_code,
                    'localProductCode':local_spediz_code,
                    'spedizDescr':spediz_description,
                    'packages': pkgTotalJSON[0],
                    'document_invoice': document_invoice,
                    'document_cin': document_cin,
                    'document_others_1': document_others_1,
                    'document_others_2': document_others_2,
                    'document_others_3': document_others_3,
                    'data_spediz' : plannedShippingDate.toLocaleDateString("en-CA"),
                    'shipping_contents' : shipping_contents, 
                    'shipping_reference' : shipping_reference, 
                    'shipping_number_reference' : number_reference, 
                    'shipping_date_billing' : shipping_date_billing, 
                    'shipping_duty_payment_type' : shipping_duty_payment_type, 
                    'shipping_account' : shipping_account,
                    'selected_return_products' : JSON.stringify({selected_return_products})
                },
            },
            flash: 1,
            handleFlashMessage: function(message, type) {
                $.oc.flashMsg({ text: message, class: type })
            },
            success: function(data) {
                console.log(data);
                if (data.error) {
                    // handle the error
                    throw data.error.msg;
                }
                var json_result = JSON.parse(data.result);
                    if($('#ritornoLabel').length !== 0){
                        $('#ritornoLabel').remove();
                    }
                    $('#appendLabel').append(`
                        <a id='ritornoLabel' class='btn btn-danger text-white' download='etichetta_reso.pdf' href='data:application/octet-stream;base64,`+json_result.documents[0].content+`'>
                            Etichetta Reso
                            <i style="font-size: 22px;" class="icon-file-pdf-o">&nbsp;<i style="font-size: 22px;" class="icon-arrow-down"></i></i>
                        </a>
                    `);
                    window.location.reload();
            }
        });
    }

    var createShipping = 'create_shipping';
    var shipping_counter = 0;
    function create_shipment_dhl(){
        var spediz_code = $('#quotazione').find(':selected').val();
        var local_spediz_code = $('#quotazione').find(':selected').attr('localcode');
        var spediz_description = $('#quotazione').find(':selected').text().replace(" €","");
        var data_spediz = $("#shipping_date_requested").val();
        let plannedShippingDate = new Date(data_spediz);
        var shipping_contents = $('#shipping_contents').val();
        var shipping_reference = $('#shipping_reference').val();
        var number_reference = $('#shipping_number_reference').val();
        var shipping_date_billing = $('#shipping_date_billing').val();
        var shipping_duty_payment_type = $('#shipping_duty_payment_type').val();
        var shipping_account = $('#shipping_account').val();
        var document_invoice = $('#base64').val();
        var document_cin = $('#base64_cin').val();
        var document_others_1 = $('#base64_others_1').val();
        var document_others_2 = $('#base64_others_2').val();
        var document_others_3 = $('#base64_others_3').val();
        if(document_others_1 == ''){
            document_others_1 = "nil";
        }
        if(document_others_2 == ''){
            document_others_2 = "nil";
        }
        if(document_others_3 == ''){
            document_others_3 = "nil";
        }
        if(document_cin == ''){
            document_cin = "nil";
        }
        $.request('onInterfaceShipping', {
            data: {
                'search' : createShipping,
                'order_id': "<?=$obOrder->id?>",
                'params':{
                    'productCode':spediz_code,
                    'localProductCode':local_spediz_code,
                    'spedizDescr':spediz_description,
                    'packages': pkgTotalJSON[0],
                    'document_invoice': document_invoice,
                    'document_cin': document_cin,
                    'document_others_1': document_others_1,
                    'document_others_2': document_others_2,
                    'document_others_3': document_others_3,
                    'data_spediz' : plannedShippingDate.toLocaleDateString("en-CA"),
                    'shipping_contents' : shipping_contents, 
                    'shipping_reference' : shipping_reference, 
                    'shipping_number_reference' : number_reference, 
                    'shipping_date_billing' : shipping_date_billing, 
                    'shipping_duty_payment_type' : shipping_duty_payment_type, 
                    'shipping_account' : shipping_account
                },
            },
            flash: 1,
            handleFlashMessage: function(message, type) {
                $.oc.flashMsg({ text: message, class: type })
            },
            success: function(data) {
                console.log(data);
                if (data.error) {
                    // handle the error
                    throw data.error.msg;
                }
                var json_result = JSON.parse(data.result);
                createShipping = 'return_shipping';
                if (shipping_counter == 0) {
                    if($('#partenzaLabel').length !== 0){
                        $('#partenzaLabel').remove();
                    }
                    $('#appendLabel').append(`
                        <a id='partenzaLabel' class='btn btn-success text-white' download='etichetta_partenza.pdf' href='data:application/octet-stream;base64,`+json_result.documents[0].content+`'>
                            Etichetta
                            <i style="font-size: 22px;" class="icon-file-pdf-o">&nbsp;<i style="font-size: 22px;" class="icon-arrow-up"></i></i>
                        </a>
                    `);
                    shipping_counter++;
                    create_shipment_dhl();
                } else if (shipping_counter == 1) {
                    if($('#ritornoLabel').length !== 0){
                        $('#ritornoLabel').remove();
                    }
                    $('#appendLabel').append(`
                        <a id='ritornoLabel' class='btn btn-danger text-white' download='etichetta_reso.pdf' href='data:application/octet-stream;base64,`+json_result.documents[0].content+`'>
                            Etichetta Reso
                            <i style="font-size: 22px;" class="icon-file-pdf-o">&nbsp;<i style="font-size: 22px;" class="icon-arrow-down"></i></i>
                        </a>
                    `);
                    shipping_counter = 0;
                    createShipping = 'create_shipping';
                    window.location.reload();
                }
                $('#quoteDHL').prop('disabled', true);
                $('#sendShippingEmail').prop('disabled', true);
            }
        });
    }

    function calculate_quotation(){
        var data_spediz = $("#shipping_date_requested").val();
        var shipping_contents = $('#shipping_contents').val();
        var shipping_reference = $('#shipping_reference').val();
        var shipping_date_billing = $('#shipping_date_billing').val();
        var shipping_duty_payment_type = $('#shipping_duty_payment_type').val();
        var conta = 0;
        $('#quotazione').empty();
        $('#shipping_account').children('option').each(function(){
            $.request('onInterfaceShipping', {
                data: {
                    'search': 'quotation',
                    'order_id': "<?=$obOrder->id?>",
                    'params':{
                        'packages': pkgTotalJSON[0],
                        'data_spediz' : data_spediz,
                        'shipping_contents' : shipping_contents, 
                        'shipping_reference' : shipping_reference, 
                        'shipping_date_billing' : shipping_date_billing, 
                        'shipping_duty_payment_type' : shipping_duty_payment_type, 
                        'shipping_account' : $(this).val(),
                    },
                },
                // le righe che seguono servono per abilitare il flashmessage utile per debug
                flash: 1,
                handleFlashMessage: function(message, type) {
                    $.oc.flashMsg({ text: message, class: type })
                },
                success: function(data) { 
                    if (data.error) {
                        // handle the error
                        console.log(JSON.parse(data.error));
                    }
                    console.log(JSON.parse(data.result)[1]);
                    var json_result = JSON.parse(data.result)[0];
                    var accountId = JSON.parse(data.result)[1];
                    for(var j=0; j<json_result.products.length; j++){
                        $('#quotazione').append(`
                            <option account="`+accountId+`" value='`+json_result.products[j].productCode+`' localcode='`+json_result.products[j].localProductCode+`' data-position='`+json_result.products[j].totalPrice[0].price+`'>
                                `+json_result.products[j].productName+` - `+json_result.products[j].totalPrice[0].price+` €
                            </option>
                        `);
                    }
                    conta++;
                    if(conta==2){
                        orderbyPrice();
                    }
                }, 
          });
        });
    }
    function orderbyPrice(){
        $("#quotazione option").sort(sort_option).appendTo('#quotazione'); // append again to the list
        $('#quotazione').children('option').not(':first').remove();
        
        var accountNumber = $('#quotazione').children('option').first().attr('account');
        $('#codice_utente').html(`
            <th style="border: 1px solid rgb(150, 150, 150);" scope="col">Account Utente</th>
            <td style="border-left: 1px solid rgb(150, 150, 150);">`+accountNumber+`</td>
        `);
        $('#shipping_account').children('option').each(function() {
           if ($(this).attr('value') == accountNumber) {
               $(this).prop('selected', true);
           } 
        });
    }
    // sort function callback
    function sort_option(a, b){
        return ($(b).data('position')) < ($(a).data('position')) ? 1 : -1;       
    }

    function setShowHideIfDirNotEmpty() {
        if ($('#checkdirexist').text() == 1) {
            $('#Form-field-OrderHelper-shipping_company-group').hide();
            $('#Form-field-OrderHelper-shipping_tracking-group').hide();
            $('#Form-field-OrderHelper-full_shipping_price-group').hide();
            $('#colonnaDhlSx').hide();
            $('#colonnaDhlDx').hide();
            $('#sendShippingEmail').hide();
            $('#quoteDHL').hide();
            $('#Form-field-OrderHelper-shipping_tracking-group').show();
            $('#labelButtonGroup').appendTo('#Form-outsideTabs');
            $('#exampleModal2').appendTo('#Form-outsideTabs');
            $('#caricaAwb').appendTo($('#Form-field-OrderHelper-email_sender-group'));
            $('#riepilogoButton').appendTo('#appendLabel');
        }
    }
    $(document).ready(function(){
        // setShowHideIfDirNotEmpty();
    });

</script>